using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;     // For reflection
using System.Windows.Forms;  // For Application path
using System.IO;

namespace BasicRefSample
{
    class Program
    {
        static void Main(string[] args)
        {
            string dllName = @"BasicRefDll.dll"; 
            // Assembly name  to load

            string myPath = (Application.StartupPath + Path.DirectorySeparatorChar + dllName);
            //Absolute path to the dll file

            Assembly asmDLL = Assembly.LoadFile(myPath);
            //Dynamically load the assembly

            Object asmObject = asmDLL.CreateInstance(@"BasicRefDll.SampleClass");
            //Instance object from the Assembly. Having NameSpace.ClassName is always a good practice

            MethodInfo theMethod = asmObject.GetType().GetMethod(@"ShowMessage");
            //From asmObject we extract the method we need

            object[] arguments = new object[] { "Go4Expert Sample" };	
            // Arguemnts we need to pass

            theMethod.Invoke(asmObject, arguments);
            // Finaly we fire method imported from the dll
        }
    }
}
